"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = require("path");

var _getProviderContent = _interopRequireDefault(require("./utils/getProviderContent"));

var _getModelContent = _interopRequireDefault(require("./utils/getModelContent"));

var _constants = require("./constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = function _default(api) {
  var paths = api.paths,
      findJS = api.findJS; // 注册 getInitialState 方法

  api.addRuntimePluginKey('getInitialState');
  api.writeTmpFile((0, _path.join)(_constants.DIR_NAME, 'Provider.tsx'), _getProviderContent.default); // Add provider to prevent render

  api.addRuntimePlugin((0, _path.join)(__dirname, './runtime'));
  api.onGenerateFiles(function () {
    var entryFile = findJS((0, _path.join)(paths.absSrcPath, 'app'));

    if (entryFile) {
      var relEntryFile = (0, _path.relative)(paths.cwd, entryFile);
      api.writeTmpFile(_constants.RELATIVE_MODEL_PATH, (0, _getModelContent.default)(relEntryFile));
    } else {
      api.writeTmpFile(_constants.RELATIVE_MODEL_PATH, "import React from 'react';\n\nexport default () => {\n  ".concat(process.env.NODE_ENV === 'development' ? "throw new Error('[@umijs/plugin-initial-state]: \u68C0\u6D4B\u5230 @umijs/plugin-initial-state \u63D2\u4EF6\u5DF2\u7ECF\u5F00\u542F\uFF0C\u4F46\u662F\u4E0D\u5B58\u5728 app.ts/js \u5165\u53E3\u6587\u4EF6\u3002');" : '', "\n  return {};\n}\n"));
    }
  });
  api.addUmiExports([{
    specifiers: ['InitialState'],
    source: (0, _path.join)(api.paths.absTmpDirPath, _constants.RELATIVE_MODEL)
  }]);
  api.register('addExtraModels', function () {
    return [{
      absPath: (0, _path.join)(paths.absTmpDirPath, _constants.RELATIVE_MODEL_PATH),
      namespace: '@@initialState'
    }];
  });
};

exports.default = _default;